#!/usr/bin/env python
# -*- coding: utf-8 -*-
# File  : classifier.py

import random
import numpy as np
from sklearn.model_selection import train_test_split
from sklearn.linear_model import LogisticRegression
from sklearn.model_selection import StratifiedKFold,cross_val_predict
from sklearn.metrics import accuracy_score
from sklearn.metrics import confusion_matrix
from sklearn.svm import SVC
from sklearn.tree import DecisionTreeClassifier
from sklearn.ensemble import RandomForestClassifier
from sklearn.neighbors import KNeighborsClassifier
from sklearn.naive_bayes import GaussianNB
from xgboost import XGBClassifier
# path = r'.\temp_data\result'
from sklearn.preprocessing import StandardScaler
import warnings
import random
warnings.filterwarnings("ignore")

def k_fold_val(tmp_clf,x,y,k):
	sn = 0.0  # 敏感性
	sp = 0.0  # 特异性
	acc = 0.0  # 正确率
	TN=0
	FP=0
	FN=0
	TP=0    
	np.random.seed(0)
	skf = StratifiedKFold(n_splits=k)
	skf.get_n_splits(x,y)  
	for train_index, test_index in skf.split(x, y):
		x_train, x_test = x[train_index], x[test_index]
		y_train, y_test = y[train_index], y[test_index]
		tmp_clf.fit(x_train, y_train)
		y_predict = tmp_clf.predict(x_test)
		confusuinMatrix = confusion_matrix(y_test, y_predict)
		TN = TN +confusuinMatrix[0][0]
		FP = FP+confusuinMatrix[0][1]
		FN =FN+ confusuinMatrix[1][0]
		TP = TP+confusuinMatrix[1][1]
	sn =float( float(TP)  /float (TP + FN))
	sp = float(float(TN) /float (TN + FP))
	bacc = float(float(sn+sp)/2.0)
	acc=float(float(TP+TN)/float(TP + FN+TN + FP))
	return ( acc)

def classification(x, y):
	np.random.seed(0)
	models = [LogisticRegression(), KNeighborsClassifier(), SVC(class_weight='balanced'), DecisionTreeClassifier(),
			  GaussianNB(), XGBClassifier(), RandomForestClassifier(n_estimators=10)]
	models_str = ['LR', 'KNN', 'SVC', 'DT', 'GNB', 'XGBoost', 'RF']

	#     models=[KNeighborsClassifier(),DecisionTreeClassifier(random_state=66),ExtraTreeClassifier(),XGBClassifier(),RandomForestClassifier(),AdaBoostClassifier(),GradientBoostingClassifier(),BaggingClassifier()]
	#     models_str=['KNNClassifier','DecisionTree','ExtraTree','XGBoost','RandomForest','AdaBoost','GradientBoost','Bagging']
	#     score_model = []
	score_dict = {}
	x = StandardScaler().fit_transform(x)

	for name, model in zip(models_str, models):

		#         print('开始训练模型：'+name)

		score = k_fold_val(model, x, y,3)
		#scoreM = confusion_matrix(y, y_pred)
		#score = float((scoreM[0,0]+scoreM[1,1]))/np.sum(scoreM)
		score_dict[name] = score

	return score_dict

def IFS(df,y,ranked_features,clf_model):
	np.random.seed(0)
	features_list = []
	scores_ = []
	# 按照feature importances 排列的特征索引
	# x = df[ranked_features].values

	for i in ranked_features:
		features_list.append(i)
		ifs_x = df[features_list].values
		ifs_x = StandardScaler().fit_transform(ifs_x)
		skf = StratifiedKFold(n_splits=3, random_state=0)
		y_pred = cross_val_predict(clf_model, ifs_x, y, cv=skf)
		score = accuracy_score(y, y_pred)
		#scores_.append(round(score,4))
		scores_.append(score)
	return scores_

